##
## DataDome f5 BigIP iRule module SSL helpers.
##
## Version 1.0
## DataDome (https://datadome.co)
##

# Based on HSSR-Helper for Mark's HTTP Super SIDEBAND Requestor! (v2.1)

when CLIENT_ACCEPTED {
 set h ""
 set prevdest [list]
 set dest [list]
 set v [list]
}

when HTTP_REQUEST {
 regexp {^[^\x5b:][^:]*} [HTTP::header value Host] h

 if {[set v [HTTP::header value X-DataDome-SSL-Helper]] ne ""} {
  HTTP::header remove X-DataDome-SSL-Helper

  set dest [lrange $v 0 2]
  if {$dest ne $prevdest} {
   LB::detach
   if {[string index [lindex $dest 0] end] eq "s"} {
    SSL::enable serverside
   } else {
    SSL::disable serverside
   }

   if {[catch {node [lindex $dest 1] [lindex $dest 2]} err]} {
    log local0.err "'node' command failed ($err) while selecting node [lrange $dest 1 2] for [lrange $v 3 4] to '${h}'"

    HTTP::respond 502 Connection close
   }
  }

  set prevdest $dest
 }
}

when LB_FAILED {
 if {[catch {LB::status} lbstatus]} { set lbstatus "unknown" }
 log local0.err "cannot connect to node [lrange $dest 1 2] for [lrange $v 3 4] to '${h}', LB::status is '${lbstatus}'"

 HTTP::respond 502 Connection close
}

when SERVERSSL_CLIENTHELLO_SEND {
 #shamelessly derived from Kevin Stewart's admirable work:
 #https://devcentral.f5.com/questions/regular-ssl-tls-for-user-connections-to-the-ltm-with-sni-support-from-ltm-to-the-real-webservers

 if {$h ne ""} {
  set k [string length $h]
  set bin [binary format S1S1S1S1ca* 0 [expr {$k + 5}] [expr {$k + 3}] 0 $k $h]
  SSL::extensions insert $bin
 }
}

#== End of HSSR-Helper for Mark's HTTP Super SIDEBAND Requestor! (v2.1) ==
